/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <device.h>

#define DMA_1_BYTES_PER_BURST 1
#define DMA_1_REQUEST_PER_BURST 1
#define DMA_1_SRC_BASE (CYDEV_PERIPH_BASE)
#define DMA_1_DST_BASE (0x20000000)
#define DMA_3_BYTES_PER_BURST 1
#define DMA_3_REQUEST_PER_BURST 1
#define DMA_3_SRC_BASE (0x20003E81)
#define DMA_3_DST_BASE (CYDEV_PERIPH_BASE)

/* Variable declarations for DMA_1 */
/* Move these variable declarations to the top of the function */
uint8 DMA_1_Chan;
uint8 DMA_1_TD[4];
uint8 DMA_3_Chan;
uint8 DMA_3_TD[1];

uint32 output_audio_val; // PseudoPointer to 8 bit output value used by the VDAC
uint32 latest_input_val; //PseudoPointer to latest acquired 8 bit ADC value from microphone
uint32 audio_circ_buffer_ptr_index; //Keeps track of the circular buffer index on audio data
uint32 echo_ptr_offset; //Pointer index to locate delayed data for echo, same can be done for flanger
uint32 echo_data; // PseudoPointer to delayed data
uint8 ndex;

void main()
{
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
	ndex = 0;
	
	//Clock_1_Stop(); // We call this early in the initialization procedure to allow time for clk1 to fully disable
	
	Opamp_1_Start();
	Opamp_2_Start();
	Opamp_3_Start();
	PGA_1_Start();
	
	/* DMA Configuration for DMA_1 */

	DMA_1_Chan = DMA_1_DmaInitialize(DMA_1_BYTES_PER_BURST, DMA_1_REQUEST_PER_BURST, 
	    HI16(DMA_1_SRC_BASE), HI16(DMA_1_DST_BASE));
	DMA_1_TD[0] = CyDmaTdAllocate();
	DMA_1_TD[1] = CyDmaTdAllocate();
	DMA_1_TD[2] = CyDmaTdAllocate();
	DMA_1_TD[3] = CyDmaTdAllocate();
	CyDmaTdSetConfiguration(DMA_1_TD[0], 4000, DMA_1_TD[1], TD_INC_SRC_ADR | TD_INC_DST_ADR);
	CyDmaTdSetConfiguration(DMA_1_TD[1], 4000, DMA_1_TD[2], TD_INC_SRC_ADR | TD_INC_DST_ADR);
	CyDmaTdSetConfiguration(DMA_1_TD[2], 4000, DMA_1_TD[3], TD_INC_SRC_ADR | TD_INC_DST_ADR);
	CyDmaTdSetConfiguration(DMA_1_TD[3], 4000, DMA_1_TD[0], TD_INC_SRC_ADR | TD_INC_DST_ADR);
	CyDmaTdSetAddress(DMA_1_TD[0], LO16((uint32)ADC_DelSig_1_DEC_SAMP_PTR), LO16((uint32)0x20000000));
	CyDmaTdSetAddress(DMA_1_TD[1], LO16((uint32)ADC_DelSig_1_DEC_SAMP_PTR), LO16((uint32)0x20000FA0));
	CyDmaTdSetAddress(DMA_1_TD[2], LO16((uint32)ADC_DelSig_1_DEC_SAMP_PTR), LO16((uint32)0x20001F40));
	CyDmaTdSetAddress(DMA_1_TD[3], LO16((uint32)ADC_DelSig_1_DEC_SAMP_PTR), LO16((uint32)0x20002EE0));
	CyDmaChSetInitialTd(DMA_1_Chan, DMA_1_TD[0]);
	CyDmaChEnable(DMA_1_Chan, 1);
//
/* Variable declarations for DMA_3 */
/* Move these variable declarations to the top of the function */


/* DMA Configuration for DMA_3 */

	DMA_3_Chan = DMA_3_DmaInitialize(DMA_3_BYTES_PER_BURST, DMA_3_REQUEST_PER_BURST, 
	    HI16(DMA_3_SRC_BASE), HI16(DMA_3_DST_BASE));
	DMA_3_TD[0] = CyDmaTdAllocate();
	CyDmaTdSetConfiguration(DMA_3_TD[0], 1, DMA_3_TD[0], TD_INC_SRC_ADR);
	CyDmaTdSetAddress(DMA_3_TD[0], LO16((uint32)0x20003E81), LO16((uint32)VDAC8_1_Data_PTR));
	CyDmaChSetInitialTd(DMA_3_Chan, DMA_3_TD[0]);
	CyDmaChEnable(DMA_3_Chan, 1);

//
	VDAC8_1_Start(); 
	
	ADC_DelSig_1_Start();
	
	isr_1_Start();
	CyGlobalIntEnable;
	
	//Clock_1_SetPhaseRegister(3);// Sets 2ns skew in analog clock
	Clock_1_Start(); // Go!!!!!
	
    for(;;)
    {
        
    }
}

/* [] END OF FILE */
